var gSearchBox;
var gMatchList;
var gMethodList;
var gClearButton;
var gBookmarksView;

if (!gPref) {
  var gPref = Components.classes["@mozilla.org/preferences-service;1"]
                        .getService(Components.interfaces.nsIPrefBranch)
                        .QueryInterface(Components.interfaces.nsIPrefBranch);
}

var xsbBookmarks = {

  initPanel : function () {
    window.removeEventListener("load", xsbBookmarks.initPanel, true);
    gSearchBox = document.getElementById("search-box");
    gClearButton = document.getElementById("clearSearch");
    gBookmarksView = document.getElementById("bookmarks-view");
  },

  initMgr : function () {
    window.removeEventListener("load", xsbBookmarks.initMgr, true);
    gSearchBox = document.getElementById("search-box");
    gMatchList = document.getElementById("xsb-matchList");
    gMethodList = document.getElementById("xsb-methodList");
    gClearButton = document.getElementById("clearSearch");
    gBookmarksView = document.getElementById("bookmarks-view");
    xsbBookmarks.initSettings();
    xsbBookmarks.addPrefObserver();
    xSidebar.extensionStartup();
    var initialRef = gBookmarksView.tree.getAttribute("ref");
    gBookmarksView.tree.setAttribute("ref", "NC:BookmarksTopRoot");
     // Search some dummy variable first to initialize bookmarksTree.xml
    gBookmarksView.searchBookmarks("NC:BookmarksTopRoot");
    gBookmarksView.searchBookmarks();
    gBookmarksView.tree.setAttribute("ref", initialRef);
    if ("arguments" in window && window.arguments[0] &&
        window.arguments[0].substring(0,5) == "find:") {
      xsbBookmarks.setRoot(window.arguments[0]);
    }
  },

  initSettings : function () {
    var showadvanced = gPref.getBoolPref("extensions.xsidebar.bookmarks.manager.showadvancedsearch");
    xSidebar.showItem("xsb-advancedsearch-box", showadvanced);
    xSidebar.showItem("bookmarks-search", "true");
  },

  unloadMgr : function () {
    xsbBookmarks.removePrefObserver();
  },

  searchBookmarks : function (aInput) {
    xsbBookmarks.setClearButton(aInput);
    gBookmarksView.searchBookmarks(aInput);
  },

  searchBookmarksManager : function (aInput) {
    xsbBookmarks.setClearButton(aInput);
    if (aInput == "") {
      gBookmarksView.searchBookmarks(aInput);
    }
    else if (!xsbBookmarks.advancedSearchMode()) {
      gBookmarksView.searchBookmarks(aInput);
    }
    else {
      var searchURI = "find:datasource=rdf:bookmarks"
      searchURI += "&match=" + gMatchList.selectedItem.value;
      searchURI += "&method=" + gMethodList.selectedItem.value;
      searchURI += "&text=" + encodeURIComponent(aInput);
      gBookmarksView.tree.setAttribute("ref", searchURI);
    }
  },

  advancedSearchMode : function (isAdvanced) {
    var advbox = document.getElementById("xsb-advancedsearch-box");
    if (isAdvanced != null) {
      advbox.hidden = !isAdvanced;
    }
    return !advbox.hidden;
  },

  setRoot : function (root) {
    gBookmarksView.tree.setAttribute("ref", root);
    var findVars = root.split("&");
    for (ii = 0; ii < findVars.length; ii++) {
      findVars[ii] = findVars[ii].split("=")[1];
    }
    //dump("setRoot :"+findVars+"\n");
    gMatchList.value = findVars[1];
    gMethodList.value = findVars[2];
    gSearchBox.value = decodeURIComponent(findVars[3]);
    gClearButton.setAttribute("disabled", "false");
  },

  /// From AIOS
  clearSearch : function() {
    gSearchBox.value = "";
    gSearchBox.focus();
    xsbBookmarks.setClearButton(gSearchBox.value);
    gBookmarksView.searchBookmarks(gSearchBox.value);
  },

  /// xSidebar additions
  setClearButton : function (aInput) {
    gClearButton.setAttribute("disabled", (aInput == "") ? "true" : "false");
  },

  /// Preferences
  prefObserver : {
    observe: function(subject, topic, data) {
    // subject is the nsIPrefBranch we're observing (after appropriate QI)
    // data is the name of the pref that's been changed (relative to subject)
      if(topic == "nsPref:changed")
        xsbBookmarks.initSettings();
    }
  },

  addPrefObserver : function () {
    xSidebar.prefBranch.addObserver("extensions.xsidebar.bookmarks.manager.", xsbBookmarks.prefObserver, false);
  },

  removePrefObserver : function () {
    if (!xSidebar.prefBranch) return;
    xSidebar.prefBranch.removeObserver("extensions.xsidebar.bookmarks.manager.", xsbBookmarks.prefObserver);
  }

}
