var gSearchBox;
var gMatchList;
var gMethodList;
var gClearButton;

if (!gPref) {
  var gPref = Components.classes["@mozilla.org/preferences-service;1"]
                        .getService(Components.interfaces.nsIPrefBranch)
                        .QueryInterface(Components.interfaces.nsIPrefBranch);
}

var xsbHistory = {

  initPanel : function () {
    window.removeEventListener("load", xsbHistory.initPanel, true);
    gSearchBox = document.getElementById("search-box");
    gClearButton = document.getElementById("clearSearch");
  },

  initMgr : function () {
    window.removeEventListener("load", xsbHistory.initMgr, true);
    gSearchBox = document.getElementById("xsb-searchField");
    gMatchList = document.getElementById("xsb-matchList");
    gMethodList = document.getElementById("xsb-methodList");
    gClearButton = document.getElementById("clearSearch");
    xsbHistory.initSettings();
    xsbHistory.addPrefObserver();
    xSidebar.extensionStartup();
/* XXX: Why does this work only if put in the onload event?
 * The original setRoot() comes from history.js which is included from
 * historyTreeOverlay.js and not history.js
*/
    setRoot = function setRoot(root) {
      xsbHistory.setRoot(root);
    }
    if (!gHistoryGrouping ||
       ("arguments" in window && window.arguments[0] && window.arguments.length >= 1)) {
      try {
        gHistoryGrouping = gPrefService.getCharPref("browser.history.grouping");
      }
      catch(e) {
        gHistoryGrouping = "day";
      }
      switch(gHistoryGrouping) {
      case "none":
        document.getElementById("groupByNone").setAttribute("checked", "true");
        break;
      case "site":
        document.getElementById("groupBySite").setAttribute("checked", "true");
        break;
      case "day":
      default:
        document.getElementById("groupByDay").setAttribute("checked", "true");
      }
      xsbHistory.setRoot(window.arguments[0]);
    }
  },

  initSettings : function () {
    var showsearchbar = gPref.getBoolPref("extensions.xsidebar.history.manager.showsearchbar");
    var showadvanced = gPref.getBoolPref("extensions.xsidebar.history.manager.showadvancedsearch");
    xSidebar.showItem("xsb-history-searchbar", showsearchbar);
    xSidebar.showItem("xsb-advancedsearch-box", showadvanced);
    xSidebar.showItem("groupingMenu", "true");
  },

  unloadMgr : function () {
    xsbHistory.removePrefObserver();
  },

  /// From Firefox
  searchHistory : function (aInput) {
    xsbHistory.setClearButton(aInput);
    if (aInput == "") {
      xsbHistory.GroupBy(gHistoryGrouping);
      return;
    }
    xsbHistory.GroupBy("find:datasource=history&match=Name&method=contains&text=" + encodeURIComponent(aInput));     
  },

  GroupBy : function (groupingType) {
    var isFind = (groupingType.substr(0, 5) == "find:");
    if (!isFind) {
      gHistoryGrouping = groupingType;
      gSearchBox.value = "";
    }
    switch(groupingType) {
      case "site":
        gHistoryTree.setAttribute("ref", "NC:HistoryRoot");
        break;
      case "dayandsite":
        gHistoryTree.setAttribute("ref", "NC:HistoryByDateAndSite");
        break;
      case "visited":
        gHistoryTree.setAttribute("ref", "NC:HistoryRoot");
        break;
      case "lastvisited":
        gHistoryTree.setAttribute("ref", "NC:HistoryRoot");
        break;
      case "day":
        gHistoryTree.setAttribute("ref", "NC:HistoryByDate");
        break;
      default:
        gHistoryTree.setAttribute("ref", groupingType);
    }
    switch(isFind? gHistoryGrouping : groupingType) {
      case "site":
      case "dayandsite":
      case "day":
        xsbHistory.SortBy("name");
        break;
      case "lastvisited":
        xsbHistory.SortBy("lastvisited");
        break;
      case "visited":
        xsbHistory.SortBy("visited");
        break;
    }
  },

  SortBy : function (sortKey) {
  // We set the sortDirection to the one before we actually want it to be in the
  // cycle list, since cycleHeader cycles it forward before doing the sort.

    var sortDirection;
    switch(sortKey) {
      case "visited":
        sortKey = "rdf:http://home.netscape.com/NC-rdf#VisitCount";
        sortDirection = "ascending";
        break;
      case "name":
        sortKey = "rdf:http://home.netscape.com/NC-rdf#Name?sort=true";
        sortDirection = "natural";
        break;
      case "lastvisited":
        sortKey = "rdf:http://home.netscape.com/NC-rdf#Date";
        sortDirection = "ascending";
        break;
      default:
        return;    
    }
    var col = document.getElementById("Name");
    col.setAttribute("sort", sortKey);
    col.setAttribute("sortDirection", sortDirection);
    var column = gHistoryTree.columns.getColumnFor(col);
    gHistoryTree.view.cycleHeader(column);
  },

  /// Advanced Search options from findHistory
  searchHistoryManager : function (aInput) {
    xsbHistory.setClearButton(aInput);
    if (aInput == "") {
      xsbHistory.GroupBy(gHistoryGrouping);
      return;
    }
    else if (!xsbHistory.advancedSearchMode()) {
      xsbHistory.GroupBy("find:datasource=history&match=Name&method=contains&text=" + encodeURIComponent(aInput));     
    }
    else {
      var searchURI = "find:datasource=history"
      searchURI += "&match=" + gMatchList.selectedItem.value;
      searchURI += "&method=" + gMethodList.selectedItem.value;
      searchURI += "&text=" + encodeURIComponent(aInput);
      xsbHistory.GroupBy(searchURI);     
    }
  },

  advancedSearchMode : function (isAdvanced) {
    var advbox = document.getElementById("xsb-advancedsearch-box");
    if (isAdvanced != null) {
      advbox.hidden = !isAdvanced;
    }
    return !advbox.hidden;
  },

  setRoot : function (root) {
    gHistoryTree.ref = root;
    var findVars = root.split("&");
    for (ii = 0; ii < findVars.length; ii++) {
      findVars[ii] = findVars[ii].split("=")[1];
    }
    dump("setRoot :"+findVars+"\n");
    gMatchList.value = findVars[1];
    gMethodList.value = findVars[2];
    gSearchBox.value = decodeURIComponent(findVars[3]);
    gClearButton.setAttribute("disabled", "false");
  },

  /// From AIOS
  clearSearch : function() {
    gSearchBox.value = "";
    gSearchBox.focus();
    xsbHistory.searchHistory(gSearchBox.value);
  },

  /// xSidebar additions
  setClearButton : function (aInput) {
    gClearButton.setAttribute("disabled", (aInput == "") ? "true" : "false");
  },

  /// Preferences

  prefObserver : {
    observe: function(subject, topic, data) {
    // subject is the nsIPrefBranch we're observing (after appropriate QI)
    // data is the name of the pref that's been changed (relative to subject)
      if(topic == "nsPref:changed")
        xsbHistory.initSettings();
    }
  },

  addPrefObserver : function () {
    xSidebar.prefBranch.addObserver("extensions.xsidebar.history.manager.", xsbHistory.prefObserver, false);
  },

  removePrefObserver : function () {
    if (!xSidebar.prefBranch) return;
    xSidebar.prefBranch.removeObserver("extensions.xsidebar.history.manager.", xsbHistory.prefObserver);
  }

}
